


/**
 * Possible states that a {@link TransferJob} can be in.
 *
 * @author mpilone/ edited by David Beecher
 */
public enum JobState {

  /**
   * Job is ready for transfer.
   */
  READY,
  /**
   * Job is actively transferring.
   */
  TRANSFERRING,
  /**
   * Job is complete and successfully transferred.
   */
  SUCCESSFUL,
  /**
   * Job is complete and failed to transfer.
   */
  FAILED,
  /**
   * Job is complete and aborted at user request.
   */
  ABORTED
}
